import getopt
import sys
from optparse import OptionParser
from xen_connection import xen_connection

class list_hosts:
    exit_code = 0
    options = None

    def set_options(self, options):
        self.options = options

    def create_xen_connection(self):
        for proto in ['http://','https://']:
            conn = xen_connection()
            conn.url = proto + self.options.host
            conn.username = self.options.user
            conn.password = self.options.password
            if (conn):
                return conn
        return

    def run(self):
        conn = self.create_xen_connection()

        try:
            hosts = conn.get_hosts()
        except Exception, e:
            print e
            conn.logout()
            return 3

        conn.logout()
        for h in hosts:
            sys.stdout.write(h['hostname'])
            if h['alive'] != True:
                self.exit_code = 2
                sys.stdout.write("(OFFLINE) ")
                continue

            sys.stdout.write("(ONLINE) ")

        if self.exit_code == 0 and conn.master_has_changed:
            sys.stdout.write("(master node has changed)")
            self.exit_code = 1

        print
        return self.exit_code
