import sys
from optparse import OptionParser
from xen_connection import xen_connection

class list_pools:
    options = None

    def set_options(self, options):
        self.options = options

    def create_xen_connection(self):
        for proto in ['http://','https://']:
            conn = xen_connection()
            conn.url = proto + self.options.host
            conn.username = self.options.user
            conn.password = self.options.password
            if (conn):
                return conn
        return

    def run(self):
        conn = self.create_xen_connection()

        try:
            pools = conn.get_pools()
        except Exception, e:
            print e
            conn.logout()
            sys.exit(3)

        conn.logout()
        if (len(pools) == 0):
            sys.stdout.write("No pools found\n")
            return 0

        exit_code = 0
        for p in pools:
            sys.stdout.write(p['uuid'])
            if p['ha_overcommitted'] == True:
                exit_code = 2
                sys.stdout.write("(OVERCOMMITTED) ")
                continue

            sys.stdout.write("(OK) ")

        if exit_code == 0 and conn.master_has_changed:
            sys.stdout.write("(master node has changed)")
            exit_code = 1

        print
        return exit_code
