import sys
from xen_connection import xen_connection

class list_vms:
    options = None

    def set_options(self, options):
        self.options = options

    def create_xen_connection(self):
        for proto in ['http://','https://']:
            conn = xen_connection()
            conn.url = proto + self.options.host
            conn.username = self.options.user
            conn.password = self.options.password
            if (conn):
                return conn
        return

    def run(self):
        conn = self.create_xen_connection()

        try:
            vms = conn.get_vms()
        except Exception, e:
            print e
            conn.logout()
            return 3

        conn.logout()
        if (len(vms) == 0):
            sys.stdout.write("No VMs found\n")
            return 0

        exit_code = 0
        error_out = ""
        ok_out = ""
        for vm in vms:

            if vm['power_state'] != "Running":
                error_out += vm['name_label'] + "(" + vm['power_state'] + ") "
                exit_code = 2
                continue

            ok_out += vm['name_label'] + "(" + vm['power_state'] + ") "


        if len(error_out) > 0:
            sys.stdout.write(error_out)
        else:
            sys.stdout.write(ok_out)

        if conn.master_has_changed:
            sys.stdout.write("(master node has changed)")
            if exit_code == 0:
                exit_code = 1

        print
        return exit_code
