from optparse import OptionParser
import classes

class plugin_runner:
	options = None
	parser = None
	args = None

	def parse_args(self):

		self.parser = OptionParser("check_xen.py -u <user> -p <password> -H <XenAPI server URL> -t <type>")
		self.parser.add_option('-u', "--user", help='Username to XenAPI authentication')
		self.parser.add_option('-p', "--password", help='Password to XenAPI authentication')
		self.parser.add_option("-H", "--host", help='Host URL to XenAPI server')
		self.parser.add_option("-t", "--type", help='Check type: listhosts, listpools, listvms, checkvm, checkhost')
		self.parser.add_option("-i", "--uuid", help='Virtual machine uuid')
		self.parser.add_option("-s", "--sub", help='Sub item to check. For hosts: memory, load, cpuN or ifN. For VMs: memory, cpuN, ifN or diskN')
		self.parser.add_option("-w", "--warning", type='float', help='Warning for sub item')
		self.parser.add_option("-c", "--critical", type='float', help='Critical for sub item')

		(self.options, self.args) = self.parser.parse_args()

		if not self.options.user:
			print "Missing user (-u)"
			return 3

		if not self.options.password:
			print "Missing password (-p)"
			return 3

		if not self.options.host:
			print "Missing XenAPI URL (-H)"
			return 3

		if not self.options.type:
			print "Missing check type (-t)"
			return 3

		return 0

	def run(self):
		if self.parse_args() != 0:
			return 3

		if self.options.type == 'listhosts':
			plugin = classes.list_hosts()

		elif self.options.type == 'listpools':
			plugin = classes.list_pools()

		elif self.options.type == 'listvms':
			plugin = classes.list_vms()

		elif self.options.type == 'checkhost':
			plugin = classes.check_host()

		elif self.options.type == 'checkvm':
			plugin = classes.check_vm()

		else:
			raise Exception("Invalid option " + self.options.type)

		plugin.set_options(self.options)
		return plugin.run()
