import XenAPI
import parse_rrd
import time
import sys

class xen_connection:
	session = None
	url = None
	username = None
	password = None
	master_has_changed = False
	default_rrd_opt = {}

	def __init__(self):
		self.default_rrd_opt['cf'] = "AVERAGE"
		self.default_rrd_opt['start'] = int(time.time()) - 120
		self.default_rrd_opt['interval'] = 10

	def create_new_session(self):
		if self.url == None:
			raise Exception("Emtpy url")

		if self.username == None:
			raise Exception("Emtpy username")

		if self.username == None:
			raise Exception("Emtpy password")

		self.session = XenAPI.Session(self.url)
		try:
			self.session.xenapi.login_with_password(self.username, self.password)
		except XenAPI.Failure, e:

			if e.details[0] != 'HOST_IS_SLAVE':
				raise

			self.session = XenAPI.Session('http://' + e.details[1])
			self.session.login_with_password(self.username, self.password)
			self.master_has_changed = True
	
	def get_pool_master(self, pool):
		if self.session == None:
			self.create_new_session()

		sx = self.session.xenapi

		masters = sx.pool.get_master(pool)
		print masters
		return

		pools = []
		for pref in pools_refs:
			record = sx.pool.get_record(pref)
			pools.append(record)

		return pools

	def get_pools(self):
		if self.session == None:
			self.create_new_session()

		sx = self.session.xenapi

		pools_refs = sx.pool.get_all()
		pools = []
		for pref in pools_refs:
			record = sx.pool.get_record(pref)
			pools.append(record)

		return pools

	def get_hosts(self):
		if self.session == None:
			self.create_new_session()

		sx = self.session.xenapi;

		hosts_refs = sx.host.get_all()
		hosts = []

		for href in hosts_refs:
			record = sx.host.get_record(href)
			record['alive'] = sx.host_metrics.get_live(record['metrics'])
			hosts.append(record)

		return hosts

	def get_host_stats(self):
		if self.session == None:
			self.create_new_session()
		
		sh = self.session.handle
		rrd_updates = parse_rrd.RRDUpdates()
		rrd_updates.refresh(sh, self.default_rrd_opt, self.url)
		params = rrd_updates.get_host_param_list()

		stats = {}
		for par in params:
			stats[par] = rrd_updates.get_host_data(par,0)

		return stats

	def get_vm_stats(self, vmuuid):
		if self.session == None:
			self.create_new_session()

		sh = self.session.handle
		rrd_updates = parse_rrd.RRDUpdates()
		rrd_updates.refresh(sh, self.default_rrd_opt, self.url)

		params = rrd_updates.get_vm_param_list(vmuuid)

		values = {}
		for param in params:
			values[param] = rrd_updates.get_vm_data(vmuuid, param, 0)

		return values

	def get_vms(self):
		if self.session == None:
			self.create_new_session()

		vms = self.session.xenapi.VM.get_all()
		parsed_vms = []
		for vm in vms:
			record = self.session.xenapi.VM.get_record(vm)
			if record['is_a_template']:
				continue

			parsed_vms.append(record)

		return parsed_vms
	
	def logout(self):
		if self.session == None:
			return
		self.session.xenapi.session.logout()
